	.8086
	.model small
	extrn	_malloc : far
	.code
	assume ds:nothing,es:nothing,ss:nothing

swapsize dw	0
dosswap	dd	0
indos	dd	0
criterr dd	0
psp	dw	0
theirpsp dw	0
theirdta dd	0
ourstack dd	0
theirstack dd	0
swaparea dd	0
oldindos db	0
dta	dd	0

	public _swapini
_swapini proc far
	push	ds  			; get swap area
	mov	ax,5d06h
	int	21h
	mov	swapsize,cx
	mov	word ptr [dosswap],si
	mov	word ptr [dosswap+2],ds
	pop	ds

	mov  	ah,34h			; get indos & criterr flags
	int	21h
	mov	word ptr [indos],bx
	mov	word ptr [indos + 2],es
	dec	bx
	mov	word ptr [criterr],bx
	mov	word ptr [indos + 2],es

	mov	ah,62h			; get PSP
	int	21h
	mov	[psp],bx

	mov	word ptr [ourstack],sp	; get our stack for TSR stack
	mov	word ptr [ourstack+2],ss

	mov	ah,2fh				; get DTA
	int	21h
	mov	word ptr [dta],bx
	mov	word ptr [dta+2],es

	push	[swapsize]		; allocate a swap area
	call	_malloc
	pop	cx
	mov	word ptr [swaparea],ax
	mov	word ptr [swaparea+2],dx

; returns dx:ax = 0 if couldn't allocate swap area
	ret
_swapini ENDP

	public ourcontext
ourcontext proc far
	pop	ax
	pop	bx
	mov	word ptr [theirstack],sp  	; switch stacks
	mov	word ptr [theirstack+2],ss
	cli
	mov	ss,word ptr [ourstack+2]
	mov	sp,word ptr [ourstack]
	push	bx
	push	ax

	mov	ah,62h				; get their PSP
	int	21h
	mov	[theirpsp],bx


	mov	ah,50h				; set our PSP
	mov	bx,[psp]
	int	21h

	lds	bx,[indos]
	mov	al,[bx]
	mov	byte ptr [bx],0
	sti
	mov	[oldindos],al
	
	lds	si,[dosswap]
	les	di,[swaparea]
	mov	cx,[swapsize]
	cld
	inc	cx
	shr	cx,1
	rep	movsw

	mov	ah,2fh				; get their DTA
	int	21h
	mov	word ptr [theirdta],bx
	mov	word ptr [theirdta+2],es

	lds	dx,[dta]			; set our DTA
	mov	ah,1ah
	int	21h

	mov	ax,@data
	mov	ds,ax
	ret
ourcontext ENDP

	public theircontext
theircontext proc far

	lds	dx,[theirdta]			; set their DTA
	mov	ah,1ah
	int	21h

	cli
	mov	al,[oldindos]
	lds	bx,[indos]			; set indos flag back
	mov	[bx],al
	sti

	lds	si,[swaparea]
	les	di,[dosswap]
	mov	cx,[swapsize]
	cld
	shr	cx,1
	rep	movsw
	adc	cx,cx
	rep	movsb

	mov	bx,[theirpsp]			; set their PSP
	mov	ah,50h
	int	21h

	pop	ax
	pop	bx
	cli
	mov	ss,word ptr [theirstack+2]	; switch stacks back
	mov	sp,word ptr [theirstack]
	sti
	push	bx
	push	ax
	ret
theircontext ENDP
	end