/*********************************************
**********************************************
This is the main ICQ file. Currently it
logs in and sits in a loop. It can receive
messages and keeps the connection alive.
Use crtl-break to exit.

This software is provided AS IS to be used in
whatever way you see fit and is placed in the
public domain.

Author : Matthew Smith April 19, 1998
Contributors : Nicolas Sahlqvist April 27, 1998
			   Ulf Hedlund (guru@slideware.com) April 28, 1998
            Michael Ivey May 4, 1998
            Michael Holzt May 5, 1998
				 David Lindauer Dec 15,1998
Changes :
   4-28-98 support for WIN32 [UH]
   4-20-98 added variable time_delay between keep_alive packets mds
   4-20-98 added instant message from server support mds
   4-21-98 changed so that long ( 250+ characters ) messages work
            new maximum is ~900 which is hopefully big enough.
            When I know more about udp maybe I can come up with
            a general solution. mds I now think ICQ has a max that is
            smaller than this so everything is ok mds I now think that
            the icq client's maximum is arbitrary and can be ignored :)
   4-23-98 Added beginnings of a user interface
   4-26-98 Changed the version to 0.2a :)
   4-27-98 Nicco added feature to use nick names to log in
   5-05-98 Authorization Messages
   5-13-98 Added time stamps for most things.
   6-17-98 Changed condition on which we should send auto_reply message. Fryslan
   6-18-98 Added different auto reply messages for different status types see also ui.c and util.c Fryslan
   6-20-98 Added an alter command to alter your command names online. Fryslan
**********************************************
**********************************************/
#include "micq.h"

BYTE Sound = SOUND_ON; /* Beeps on by default */
BYTE Sound_Str[150];  /* the command to run from the shell to play sound files */
BOOL Russian = FALSE; /* Do we do kio8-r <->Cp1251 codeset translation? */
BOOL Logging = TRUE;  /* Do we log messages to ~/micq_log?  This should probably have different levels */
BOOL Color = TRUE; /* Do we use ANSI color? */
BOOL Quit = FALSE;    /* set when it's time to exit the program */
BOOL Verbose = FALSE; /* this is displays extra debuging info */
BOOL serv_mess[ 1024 ]; /* used so that we don't get duplicate messages with the same SEQ */
WORD last_cmd[ 1024 ]; /* command issued for the first 1024 SEQ #'s */
/******************** if we have more than 1024 SEQ this will need some hacking */
WORD seq_num = 1;  /* current sequence number */
DWORD our_ip = 0x0100007f; /* localhost for some reason */
DWORD our_port; /* the port to make tcp connections on */
/************ We don't make tcp connections yet though :( */
DWORD UIN; /* current User Id Number */
BOOL Contact_List = FALSE; /* I think we always have a contact list now */
Contact_Member Contacts[ 100 ]; /* no more than 100 contacts max */
int Num_Contacts=0;
DWORD Current_Status=STATUS_OFFLINE;
DWORD last_recv_uin=0;
char passwd[100];
char server[100];
DWORD set_status;
DWORD remote_port;
BOOL Done_Login=FALSE;
BOOL auto_resp=FALSE;
char auto_rep_str_dnd[450] = { "Don't page me, my head is hurting!" };
char auto_rep_str_away[450] = { "I told you I wasn't here!" };
char auto_rep_str_na[450] = { "Working, working always working..." };
char auto_rep_str_occ[450] = { "I am working on opening this beer so I am busy." };
char auto_rep_str_inv[450] = { "So you can see me, so you can't!" };
char message_cmd[16];
char info_cmd[16];
char quit_cmd[16];
char reply_cmd[16];
char again_cmd[16];
char add_cmd[16];

char list_cmd[16];
char away_cmd[16];
char na_cmd[16];
char dnd_cmd[16];
char online_cmd[16];
char occ_cmd[16];
char ffc_cmd[16];
char inv_cmd[16];
char status_cmd[16];
char auth_cmd[16];
char auto_cmd[16];
char change_cmd[16];
char search_cmd[16];
char save_cmd[16];
char alter_cmd[16];
char msga_cmd[16];
char url_cmd[16];
char update_cmd[16];

/*/////////////////////////////////////////////
// Connects to hostname on port port
// hostname can be DNS or nnn.nnn.nnn.nnn
// write out messages to the FD aux */
P_SOK_T Connect_Remote( char *hostname, DWORD port, FD_T aux )
{

   DWORD conct, length;
   static SOK_T sokx;
#ifndef _MSDOS
   struct sockaddr_in sin;  /* used to store inet addr stuff */
   struct hostent *host_struct; /* used in DNS lookup */
#else
	longword host;
#endif

#ifndef _MSDOS
#if 1
	sin.sin_addr.s_addr = inet_addr( hostname ); 
  	if ( sin.sin_addr.s_addr  == MINUSONE ) /* name isn't n.n.n.n so must be DNS */
#else

	if ( inet_aton( hostname, &sin.sin_addr )  == 0 ) /* checks for n.n.n.n notation */
#endif
	{
	   host_struct = gethostbyname( hostname );/* name isn't n.n.n.n so must be DNS */
      if ( host_struct == NULL )
#else
			if (!(host = resolve(hostname)))
#endif
      {
         if ( Verbose )
         {
            M_fdprint( aux, "Shakespeare couldn't spell why should I?\n" );
            M_fdprint( aux, " Especially something like %s\n", hostname );
            /*herror( "Can't find hostname" );*/
         }
         return 0;
      }
#ifndef _MSDOS
	   sin.sin_addr = *((struct in_addr *)host_struct->h_addr);
   }
	sin.sin_family = AF_INET; /* we're using the inet not appletalk*/
	sin.sin_port = htons( port );	/* port */
	sokx = socket( AF_INET, SOCK_DGRAM, 0 );/* create the unconnected socket*/
   if ( sokx == MINUSONE ) 
   {          
      perror( "Socket creation failed" );
      exit( 1 );
   }   
   if ( Verbose )
   {
      M_fdprint( aux, "Socket created attempting to connect\n" );
   }
	conct = connect( sokx, (struct sockaddr *) &sin, sizeof( sin ) );
	if ( conct == MINUSONE )/* did we connect ?*/
#else
	if (!udp_open(&sokx.udp,0,host,port,NULL))
#endif
	{
      if ( Verbose )
      {
   	   M_fdprint( aux, " Conection Refused on port %d at %s\n", port, hostname );
         #ifdef FUNNY_MSGS
            M_fdprint( aux, " D'oh!\n" );
         #endif
   	   perror( "connect" );
      }
	   return 0;
	}
#ifndef _MSDOS
   length = sizeof( sin ) ;
   getsockname( sokx, (struct sockaddr *) &sin, &length );
   our_ip = sin.sin_addr.s_addr;
   our_port = sin.sin_port;
   if (Verbose )
   {
      #ifdef FUNNY_MSGS
         M_fdprint( aux, "Our port is l%d, take her to sea Mr. Mordoch.\n", ntohs( sin.sin_port ) );
      #else
         M_fdprint( aux, "The port that will be used for tcp ( not yet implemented ) is %ld\n", ntohs( sin.sin_port ) );
      #endif
   }
#else
	 our_ip = gethostid();
	 our_port = 0; /* incoming TCP port not supported yet */
#endif
   if ( Verbose )
   {
      M_fdprint( aux, "Connected to %s, waiting for response\n", hostname );
   }
   return &sokx;
}


/******************************************
Handles packets that the server sends to us.
*******************************************/
void Handle_Server_Response( P_SOK_T sok )
{
   srv_net_icq_pak pak;
   int s;
   
   s = SOCKREAD( sok, &pak.head.ver, sizeof( pak ) - 2  );
   if ( s < 0 )
   	return;

#if 0    /* V4 testing */
       M_print( CLIENTCOL "\nThe response was %04X\t", Chars_2_Word( pak.head.cmd ) );
       M_print( "The version was %X\t", Chars_2_Word( pak.head.ver ) );
       Time_Stamp();
       M_print( "\nThe SEQ was %04X\t", Chars_2_Word( pak.head.seq ) );
       len = s - ( sizeof( pak.head ) - 2 );
       M_print( "The size was %d\n", len );
       if ( Verbose )
       {
            Hex_Dump( pak.data, len );
       }
       M_print( NOCOL "\n" );
       Prompt(0);
       ack_srv( sok, Chars_2_Word( pak.head.seq ) ); /* fake like we know what we're doing*/
   return;
#endif
      
   if ( ( serv_mess[ Chars_2_Word( pak.head.seq ) ] ) && 
      ( Chars_2_Word( pak.head.cmd ) != SRV_NEW_UIN ) )
   {
      if ( Chars_2_Word( pak.head.cmd ) != SRV_ACK ) /* ACKs don't matter */
      {
         if ( Verbose )
            M_print( "\nIgnored a message cmd  %04x\n", Chars_2_Word( pak.head.cmd )  );
         ack_srv( sok, Chars_2_Word( pak.head.seq ) ); /* LAGGGGG!! */
         return;
      }
   }
   if ( Chars_2_Word( pak.head.cmd ) != SRV_ACK )
   {
      serv_mess[ Chars_2_Word( pak.head.seq ) ] = TRUE;
      ack_srv( sok, Chars_2_Word( pak.head.seq ) );
   }

   Server_Response( sok, pak.data, s - ( sizeof( pak.head ) - 2 ), 
      Chars_2_Word( pak.head.cmd ), Chars_2_Word( pak.head.ver ),
      Chars_2_Word( pak.head.seq ), Chars_2_DW( pak.head.UIN ) );
}

/**********************************************
Verifies that we are in the correct endian
***********************************************/
void Check_Endian( void )
{
#ifndef _MSDOS
   int i;
   char passwd[10];
   
   passwd[0] = 1;
   passwd[1] = 0;
   passwd[2] = 0;
   passwd[3] = 0;
   passwd[4] = 0;
   passwd[5] = 0;
   passwd[6] = 0;
   passwd[7] = 0;
   passwd[8] = 0;
   passwd[9] = 0;
   i = *  ( DWORD *) passwd;
   if ( i == 1 )
   {
      M_print( "Using intel byte ordering.\n" );
   }
   else
   {
      M_print( "Using motorola byte ordering.\n" );
   }
#endif
}

static P_SOK_T sok;
int lasttick;
int elapsedticks;

int seconds = 120;
int resend_seconds = 10;
#ifdef _MSDOS
unsigned far *biostick = MK_FP(0x40,0x6c);
#endif
int hooked, dovga,toexit;
void upcall(int toquit);
void retime(void);
/******************************
Main function connects gets UIN
and passwd and logins in and sits
in a loop waiting for server responses.
******************************/
int main( int argc, char *argv[] )
{
   DWORD i;
	 void *ss;
#ifdef _WIN32
   WSADATA wsaData;
#endif
#ifdef _TSRMSDOS
	for (i=1; i < argc; i++) {
		if (!strcmp(argv[i],"/r"))
			hooked = 1;
		if (!strcmp(argv[i],"/v"))
			dovga = 1;
		if (!strcmp(argv[i],"/V"))
			Verbose++;
	}
#else
   if (argc > 1 )
   {
      for ( i=1; i< argc; i++ )
      {
         if ( argv[i][0] != '-' )
         ;
         else if ( (argv[i][1] == 'v' ) || (argv[i][1] == 'V' ) )
         {
            Verbose++;
         }
      }
   }
#endif

#ifdef _TSRMSDOS
	dovga = dovga && hooked;
	if ((getdosver() >> 8) < 5) {
		printf("This program needs DOS 5.0 or better");
		return 1;
	}
	if (isloaded()) {
		unload();
		return 0;
	}
	if (dovga && !isvga()) {	 
		int a;
		printf("\nYou do not have a VGA card.  The screen presentation may not\n"
						"be correct without VGA.  Would you like to continue (Y/N)?");
		a = getch();
		if (a != 'y' && a != 'Y')
			return 1;
		printf("\n\n");
	}
#endif
#ifdef _MSDOS
#ifndef TESTING
   sock_init();
#endif
#endif
   Initialize_Msg_Queue();
   Get_Config_Info(argv[0]);
   if ( !strcmp( passwd,"" ) )
   {
      M_print( "Enter password : " );
      fflush( stdout );
      Echo_Off();
      M_fdnreadln(STDIN, passwd, sizeof(passwd));
      Echo_On();
   }
   memset( serv_mess, FALSE, 1024 );
   Check_Endian();
#ifdef _WIN32
   i = WSAStartup( 0x0101, &wsaData );
   if ( i != 0 ) {
#ifdef FUNNY_MSGS
		perror("Windows Sockets broken blame Bill -");
#else
		perror("Sorry, can't initialize Windows Sockets...");
#endif
	    exit(1);
   }
#endif
#ifndef TESTING
   sok = Connect_Remote( server, remote_port, STDERR );
   if ( ( sok == (P_SOK_T) MINUSONE ) || ( sok == 0 ) ) 
   {
   	M_print( "Couldn't establish connection\n" );
   	exit( 1 );
   }
   Login( sok, UIN, &passwd[0], our_ip, our_port, set_status );
#endif
#ifdef _TSRMSDOS
	if (hooked && !swapini()) {
		printf("Can't load");
		return 1;
	}
	if (hooked)
		printf("MICQ is going resident, hot key is alt-tab\n");
	hook10(dovga,hooked);
	hook8(hooked);
	if (hooked) {
		hook2f();
		drawbottom();
	}
#endif
	M_print("\n");
   M_print( SERVCOL "Matt's ICQ clone " NOCOL "compiled on %s %s\n" SERVCOL " Version " MICQ_VERSION NOCOL "\n", __TIME__, __DATE__ );
#ifdef FUNNY_MSGS
   M_print( "\nNo Mirabilis client was maimed, hacked, tortured, sodomized or otherwise harmed\nin the making of this utility.\n" );
#else
   M_print( "\nThis program was made without any help from Mirabilis or their consent.\n" );
   M_print( "No reverse engineering or decompilation of any Mirabilis code took place\nto make this program.\n" );
#endif
  Prompt(0);
#ifdef _TSRMSDOS
	if (hooked) {
		gotsr();
	}
	else {
		seconds = 120;
    resend_seconds = 10;
		elapsedticks = 0;
		lasttick = *biostick;
		while (!toexit) {
			upcall(0);
			if (lasttick != *biostick) {
				elapsedticks+= *biostick - lasttick;
				lasttick = *biostick;
				retime();
			}
		}
	}
#else
		seconds = 120;
    resend_seconds = 10;
		lasttick = time(NULL);
		while (!toexit) {
			int x = time(NULL);
			upcall(0);
			if (lasttick != x) {
				elapsedticks = x - lasttick;
				lasttick = x;
				seconds-=elapsedticks;
				if (seconds < 0)
					seconds = 0;
				resend_seconds-=elapsedticks;
				if (resend_seconds < 0)
					resend_seconds = 0;
			}
		}
#endif
}
void retime(void)
{
 	int v = elapsedticks/18;
	if (v)
 		elapsedticks = elapsedticks %18;
 	seconds-=v;
 	if (seconds < 0)
 		seconds = 0;
	resend_seconds-=v;
	if (resend_seconds < 0)
		resend_seconds = 0;
}
void tickcall(void)
{
	elapsedticks++;
  retime();
}
void upcall(int toquit)
{
   DWORD i;
   DWORD time_delay = 120;
#ifndef _MSDOS
   struct timeval tv;
   fd_set readfds;
#endif
	if (toquit || Quit) {
#ifdef _TSRMSDOS
		int cantermin = CanUnHook();
		if (cantermin)
			unhook10();
		if (hooked && cantermin) {
			unhook8();
			unhook2f();
		}
#endif
#ifndef TESTING
  	Quit_ICQ( sok );
#ifdef _TSRMSDOS
		if (!toquit && hooked && !toexit)
			sock_exit();
#endif
#endif
#ifdef _TSRMSDOS
		if (hooked && cantermin) {
    	reset_video();
		}
		if (!hooked || cantermin)
			printf("\nMICQ is unloaded (may need to press a key to get a prompt)\n");
		else
			printf("\nMICQ is not unloaded, unload TSRs above it then type MICQ to unload\n");
		if (hooked && cantermin) {
			freetsr();
		}
#endif
		toexit = TRUE;
		return;
	}

#ifndef _MSDOS
#ifdef UNIX
	  tv.tv_sec = 2;
      tv.tv_usec = 500000;
#else
	  tv.tv_sec = 0;
      tv.tv_usec = 100000;
#endif

      FD_ZERO(&readfds);
      FD_SET(sok, &readfds);

      /* don't care about writefds and exceptfds: */
      select(sok+1, &readfds, NULL, NULL, &tv);

      if (FD_ISSET(sok, &readfds))
#else
#ifndef TESTING
      if (!tcp_tick(sok)) {
        M_print("\nHost closed-aborting\n");
        return;
      }

			if (sock_dataready(sok))
#endif
#endif
#ifndef TESTING
          Handle_Server_Response( sok );
#endif
      Get_Input( sok );
			if (!seconds)
      {
				 seconds = 120;
         Keep_Alive( sok );
      }
      if (!resend_seconds )
      {
				resend_seconds = 10;
        Do_Resend( sok );
      }

#ifdef UNIX
      while(waitpid(MINUSONE,NULL,WNOHANG) > 0); /* clean up child processes */
#endif
}